int niveau_Chlore;
#define TdsSensorPin A0
#define VREF 5.0      // analog reference voltage(Volt) of the ADC
#define SCOUNT  30           // sum of sample point
int analogBuffer[SCOUNT];    // store the analog value in the array, read from ADC
int analogBufferTemp[SCOUNT];
int analogBufferIndex = 0,copyIndex = 0;
float averageVoltage = 0,tdsValue = 0,temperature = 25;
float idealTds;
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
LiquidCrystal_I2C lcd(0x27,16,2);
void setup() {
  pinMode(13, OUTPUT); // met la broche numérique en sortie
  pinMode(12, OUTPUT); // met la broche numérique en sortie
  pinMode(11, OUTPUT); // met la broche numérique en sortie
  pinMode(10, OUTPUT); // met la broche numérique en sortie
  pinMode(8, OUTPUT);
  pinMode(3, INPUT); //bouton en input
  pinMode(TdsSensorPin,INPUT);
  digitalWrite(13, HIGH);
  digitalWrite(12, HIGH);
  digitalWrite(11, HIGH);
  digitalWrite(10, HIGH);
  digitalWrite(8, HIGH); // puisqu' on utilise un relayeur, avoir notre Pin sur High éteint la pompe
  lcd.init(); // initialize the lcd    
  lcd.backlight();
  Serial.begin(9600); // ouvre le port série
}

int getMedianNum(int bArray[], int iFilterLen) 
{
      int bTab[iFilterLen];
      for (byte i = 0; i<iFilterLen; i++)
      bTab[i] = bArray[i];
      int i, j, bTemp;
      for (j = 0; j < iFilterLen - 1; j++) 
      {
      for (i = 0; i < iFilterLen - j - 1; i++) 
          {
        if (bTab[i] > bTab[i + 1]) 
            {
        bTemp = bTab[i];
            bTab[i] = bTab[i + 1];
        bTab[i + 1] = bTemp;
         }
      }
      }
      if ((iFilterLen & 1) > 0)
    bTemp = bTab[(iFilterLen - 1) / 2];
      else
    bTemp = (bTab[iFilterLen / 2] + bTab[iFilterLen / 2 - 1]) / 2;
      return bTemp;
}

void loop() {
  niveau_Chlore = analogRead(A1);
  idealTds= 180;
  if (niveau_Chlore < 1020) { digitalWrite(13, LOW); } // éteint la LED
  else {digitalWrite(13, HIGH); }
  if (niveau_Chlore < 820) { digitalWrite(12, LOW); } // éteint la LED
  else {digitalWrite(12, HIGH); }
  if (niveau_Chlore < 620) { digitalWrite(11, LOW); } // éteint la LED
  else {digitalWrite(11, HIGH); }

  static unsigned long analogSampleTimepoint = millis();
   if(millis()-analogSampleTimepoint > 40U)     //every 40 milliseconds,read the analog value from the ADC
   {
     analogSampleTimepoint = millis();
     analogBuffer[analogBufferIndex] = analogRead(TdsSensorPin);    //read the analog value and store into the buffer
     analogBufferIndex++;
     if(analogBufferIndex == SCOUNT) 
         analogBufferIndex = 0;
   }   
   static unsigned long printTimepoint = millis();
   if(millis()-printTimepoint > 800U)
   {
      printTimepoint = millis();
      for(copyIndex=0;copyIndex<SCOUNT;copyIndex++)
        analogBufferTemp[copyIndex]= analogBuffer[copyIndex];
      averageVoltage = getMedianNum(analogBufferTemp,SCOUNT) * (float)VREF / 1024.0; // read the analog value more stable by the median filtering algorithm, and convert to voltage value
      float compensationCoefficient=1.0+0.02*(temperature-25.0);    //temperature compensation formula: fFinalResult(25^C) = fFinalResult(current)/(1.0+0.02*(fTP-25.0));
      float compensationVolatge=averageVoltage/compensationCoefficient;  //temperature compensation
      tdsValue=(133.42*compensationVolatge*compensationVolatge*compensationVolatge - 255.86*compensationVolatge*compensationVolatge + 857.39*compensationVolatge)*0.5; //convert voltage value to tds value
      //Serial.print("voltage:");
      //Serial.print(averageVoltage,2);
      //Serial.print("V   ");
     // Serial.print("TDS Value:");
      //Serial.print(tdsValue,0);
      //Serial.println("ppm");
      lcd.clear();
      lcd.print("TDS Value:"); 
      lcd.print(tdsValue);
      if (digitalRead(3)== HIGH){
        if (tdsValue<idealTds)
      {
          digitalWrite(8, LOW);
        }
        else{
          digitalWrite(8, HIGH);
        }
    }
     else{ digitalWrite(8, HIGH);}
     delay(1000); // attend une seconde
   }
}
